#!/usr/bin/env ruby

class RxlData < Object

  def initialize
	  @data = Hash.new	# rows where each row is a hash of columns and values
  end
  
  def clone
	n = RxlData.new
	self.each { |c,v| n.set(c, v) }
    n
  end
 
  def get(cell)
    c, r = RxlData::parse(cell)
	  (@data[r] ? @data[r][c] : nil)
  end

  def set(cell, val)
    c, r = RxlData::parse(cell)
	  @data[r] = {} unless @data[r]
	  @data[r][c] = val if (r && c)
  end

  def size
	  [cols.size, rows.size]
  end
  
  def cols
    @data.values.collect { |r| r.keys }.flatten.uniq
  end
  
  def rows
	  @data.keys.uniq
  end

  # Call block for each cell (in natural reading order)
  def each
    @data.each do |r,row|
	    row.each do |c,v| 
	      yield(c+r,v) if block_given?
	    end
	  end
	end

  # Remove leading and tracing columns and rows with no data
  def strip
  end

  def RxlData.parse(str)
 	  c = str.scan(/\D+/).first.upcase		# ABC
	  r = str.scan(/\d+/).first				    # 123
	  [c, r]
  end
  
end
   
